# coding: utf-8

"""
    Jupyter Server API

    Server API

    The version of the OpenAPI document: 5
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional, Union
from pydantic import BaseModel, StrictFloat, StrictInt, StrictStr
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class APIStatus(BaseModel):
    """
    Notebook server API status. Added in notebook 5.0. 
    """ # noqa: E501
    started: Optional[StrictStr] = Field(default=None, description="ISO8601 timestamp indicating when the notebook server started. ")
    last_activity: Optional[StrictStr] = Field(default=None, description="ISO8601 timestamp indicating the last activity on the server, either on the REST API or kernel activity. ")
    connections: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The total number of currently open connections to kernels. ")
    kernels: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The total number of running kernels. ")
    __properties: ClassVar[List[str]] = ["started", "last_activity", "connections", "kernels"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of APIStatus from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of APIStatus from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "started": obj.get("started"),
            "last_activity": obj.get("last_activity"),
            "connections": obj.get("connections"),
            "kernels": obj.get("kernels")
        })
        return _obj


