# coding: utf-8

"""
    Jupyter Server API

    Server API

    The version of the OpenAPI document: 5
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr
from pydantic import Field
from nbserv_client.models.kernel_spec_file import KernelSpecFile
from nbserv_client.models.kernel_spec_resources import KernelSpecResources
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class KernelSpec(BaseModel):
    """
    Kernel spec (contents of kernel.json)
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="Unique name for kernel")
    kernel_spec_file: Optional[KernelSpecFile] = Field(default=None, alias="KernelSpecFile")
    resources: Optional[KernelSpecResources] = None
    __properties: ClassVar[List[str]] = ["name", "KernelSpecFile", "resources"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of KernelSpec from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of kernel_spec_file
        if self.kernel_spec_file:
            _dict['KernelSpecFile'] = self.kernel_spec_file.to_dict()
        # override the default output from pydantic by calling `to_dict()` of resources
        if self.resources:
            _dict['resources'] = self.resources.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of KernelSpec from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "KernelSpecFile": KernelSpecFile.from_dict(obj.get("KernelSpecFile")) if obj.get("KernelSpecFile") is not None else None,
            "resources": KernelSpecResources.from_dict(obj.get("resources")) if obj.get("resources") is not None else None
        })
        return _obj


